using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;
using mshtml;

namespace MyCustomWebBrowser
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class FormMain : System.Windows.Forms.Form,
                          IOleClientSite, IDocHostUIHandler, ICustomMethods,
                          IOleDocumentSite, IDocHostShowUI
	{
    #region Controls
    private System.Windows.Forms.ImageList imageListToolbar;
    private System.Windows.Forms.ToolBar toolBar1;
    private System.Windows.Forms.ToolBarButton toolBarButtonBack;
    private System.Windows.Forms.ToolBarButton toolBarButtonForward;
    private System.Windows.Forms.ToolBarButton toolBarButtonStop;
    private System.Windows.Forms.ToolBarButton toolBarButtonRefresh;
    private System.Windows.Forms.ToolBarButton toolBarButtonHome;
    private System.Windows.Forms.ToolBarButton toolBarButtonSearch;
    private System.Windows.Forms.ToolBarButton toolBarButtonPrint;
    private System.Windows.Forms.ToolBarButton toolBarButtonFileSave;
    private System.Windows.Forms.Panel panelMain;
    private AxSHDocVw.AxWebBrowser axWebBrowser1;
    private System.Windows.Forms.TextBox textBoxAddress;
    private System.Windows.Forms.MenuItem menuItem1;
    private System.Windows.Forms.MenuItem menuItem2;
    private System.Windows.Forms.ContextMenu myCustomContextMenu;
    private System.ComponentModel.IContainer components;
    #endregion

		public FormMain()
		{
      InitializeComponent();

      // tell WebBrowser that we are its host
      object obj = axWebBrowser1.GetOcx();
      IOleObject oc = obj as IOleObject;
      oc.SetClientSite(this);

      toolBarButtonRefresh.Enabled = false;
      toolBarButtonHome.Enabled = false;
      toolBarButtonSearch.Enabled = false;
      toolBarButtonPrint.Enabled = false;
      toolBarButtonFileSave.Enabled = false;
      
      axWebBrowser1.GoHome();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.components = new System.ComponentModel.Container();
      System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormMain));
      this.imageListToolbar = new System.Windows.Forms.ImageList(this.components);
      this.toolBar1 = new System.Windows.Forms.ToolBar();
      this.toolBarButtonBack = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonForward = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonStop = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonRefresh = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonHome = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonSearch = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonPrint = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonFileSave = new System.Windows.Forms.ToolBarButton();
      this.textBoxAddress = new System.Windows.Forms.TextBox();
      this.panelMain = new System.Windows.Forms.Panel();
      this.axWebBrowser1 = new AxSHDocVw.AxWebBrowser();
      this.menuItem1 = new System.Windows.Forms.MenuItem();
      this.menuItem2 = new System.Windows.Forms.MenuItem();
      this.myCustomContextMenu = new System.Windows.Forms.ContextMenu();
      this.panelMain.SuspendLayout();
      ((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).BeginInit();
      this.SuspendLayout();
      // 
      // imageListToolbar
      // 
      this.imageListToolbar.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
      this.imageListToolbar.ImageSize = new System.Drawing.Size(16, 16);
      this.imageListToolbar.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageListToolbar.ImageStream")));
      this.imageListToolbar.TransparentColor = System.Drawing.Color.Lime;
      // 
      // toolBar1
      // 
      this.toolBar1.AutoSize = false;
      this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
                                                                                this.toolBarButtonBack,
                                                                                this.toolBarButtonForward,
                                                                                this.toolBarButtonStop,
                                                                                this.toolBarButtonRefresh,
                                                                                this.toolBarButtonHome,
                                                                                this.toolBarButtonSearch,
                                                                                this.toolBarButtonPrint,
                                                                                this.toolBarButtonFileSave});
      this.toolBar1.ButtonSize = new System.Drawing.Size(18, 18);
      this.toolBar1.DropDownArrows = true;
      this.toolBar1.ImageList = this.imageListToolbar;
      this.toolBar1.Name = "toolBar1";
      this.toolBar1.ShowToolTips = true;
      this.toolBar1.Size = new System.Drawing.Size(530, 30);
      this.toolBar1.TabIndex = 1;
      this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
      // 
      // toolBarButtonBack
      // 
      this.toolBarButtonBack.ImageIndex = 0;
      this.toolBarButtonBack.ToolTipText = "Go Back";
      // 
      // toolBarButtonForward
      // 
      this.toolBarButtonForward.ImageIndex = 1;
      this.toolBarButtonForward.ToolTipText = "Go Forward";
      // 
      // toolBarButtonStop
      // 
      this.toolBarButtonStop.ImageIndex = 2;
      this.toolBarButtonStop.ToolTipText = "Stop";
      // 
      // toolBarButtonRefresh
      // 
      this.toolBarButtonRefresh.ImageIndex = 3;
      this.toolBarButtonRefresh.ToolTipText = "Refresh";
      // 
      // toolBarButtonHome
      // 
      this.toolBarButtonHome.ImageIndex = 4;
      this.toolBarButtonHome.ToolTipText = "Home";
      // 
      // toolBarButtonSearch
      // 
      this.toolBarButtonSearch.ImageIndex = 5;
      this.toolBarButtonSearch.ToolTipText = "Search";
      // 
      // toolBarButtonPrint
      // 
      this.toolBarButtonPrint.ImageIndex = 6;
      this.toolBarButtonPrint.ToolTipText = "Print";
      // 
      // toolBarButtonFileSave
      // 
      this.toolBarButtonFileSave.ImageIndex = 7;
      this.toolBarButtonFileSave.ToolTipText = "File Save";
      // 
      // textBoxAddress
      // 
      this.textBoxAddress.AcceptsReturn = true;
      this.textBoxAddress.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.textBoxAddress.Location = new System.Drawing.Point(196, 4);
      this.textBoxAddress.Name = "textBoxAddress";
      this.textBoxAddress.Size = new System.Drawing.Size(332, 20);
      this.textBoxAddress.TabIndex = 2;
      this.textBoxAddress.Text = "";
      this.textBoxAddress.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBox1_KeyDown);
      this.textBoxAddress.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.textBoxAddress_KeyPress);
      // 
      // panelMain
      // 
      this.panelMain.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
      this.panelMain.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                            this.axWebBrowser1});
      this.panelMain.Dock = System.Windows.Forms.DockStyle.Fill;
      this.panelMain.Location = new System.Drawing.Point(0, 30);
      this.panelMain.Name = "panelMain";
      this.panelMain.Size = new System.Drawing.Size(530, 359);
      this.panelMain.TabIndex = 3;
      // 
      // axWebBrowser1
      // 
      this.axWebBrowser1.ContainingControl = this;
      this.axWebBrowser1.Dock = System.Windows.Forms.DockStyle.Fill;
      this.axWebBrowser1.Enabled = true;
      this.axWebBrowser1.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("axWebBrowser1.OcxState")));
      this.axWebBrowser1.Size = new System.Drawing.Size(526, 355);
      this.axWebBrowser1.TabIndex = 0;
      this.axWebBrowser1.NavigateError += new AxSHDocVw.DWebBrowserEvents2_NavigateErrorEventHandler(this.axWebBrowser1_NavigateError);
      this.axWebBrowser1.CommandStateChange += new AxSHDocVw.DWebBrowserEvents2_CommandStateChangeEventHandler(this.axWebBrowser1_CommandStateChange);
      this.axWebBrowser1.DownloadComplete += new System.EventHandler(this.axWebBrowser1_DownloadComplete);
      this.axWebBrowser1.NavigateComplete2 += new AxSHDocVw.DWebBrowserEvents2_NavigateComplete2EventHandler(this.axWebBrowser1_NavigateComplete2);
      this.axWebBrowser1.BeforeNavigate2 += new AxSHDocVw.DWebBrowserEvents2_BeforeNavigate2EventHandler(this.axWebBrowser1_BeforeNavigate2);
      // 
      // menuItem1
      // 
      this.menuItem1.Index = 0;
      this.menuItem1.Text = "&Print";
      // 
      // menuItem2
      // 
      this.menuItem2.Index = 1;
      this.menuItem2.Text = "&Help";
      // 
      // myCustomContextMenu
      // 
      this.myCustomContextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                        this.menuItem1,
                                                                                        this.menuItem2});
      // 
      // FormMain
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(530, 389);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.panelMain,
                                                                  this.textBoxAddress,
                                                                  this.toolBar1});
      this.Name = "FormMain";
      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
      this.Text = "MyCustomWebBrowser";
      this.panelMain.ResumeLayout(false);
      ((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).EndInit();
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
      Application.Run(new FormMain());
		}

    private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
    {
      Cursor = Cursors.WaitCursor;
      try
      {
        DoToolbarCommand(e.Button);
      }
      finally
      {
        Cursor = Cursors.Default;
      }
    }

    void DoToolbarCommand(ToolBarButton theButton)
    {
      if (theButton == null) return;

      if (theButton == toolBarButtonBack)
      {
        axWebBrowser1.GoBack();
      }

      else if (theButton == toolBarButtonForward)
      {
        axWebBrowser1.GoForward();
      }

      else if (theButton == toolBarButtonStop) 
      {
        axWebBrowser1.Stop();
        toolBarButtonStop.Enabled = false;
      }
	
      else if (theButton == toolBarButtonSearch)
      {
        toolBarButtonStop.Enabled = true;
        axWebBrowser1.GoSearch();
      }

      else if (theButton == toolBarButtonPrint)
      {
        PrintPage();
      }

      else if (theButton == toolBarButtonRefresh)
      {
        toolBarButtonStop.Enabled = true;
        object REFRESH_COMPLETELY = 3;
        axWebBrowser1.Refresh2(ref REFRESH_COMPLETELY); 
      }
			
      else if (theButton == toolBarButtonHome)
      {
        toolBarButtonStop.Enabled = true;
        axWebBrowser1.GoHome();
      }

      else if (theButton == toolBarButtonFileSave)
      {
        SavePage();
      }
    }

    bool IsStopEnabled()
    {
      return IsCommandEnabled(SHDocVw.OLECMDID.OLECMDID_STOP);
    }

    private bool IsCommandEnabled(SHDocVw.OLECMDID theCommand)
    {
      int response = 
        (int) axWebBrowser1.QueryStatusWB(theCommand);
      return (response & (int) SHDocVw.OLECMDF.OLECMDF_ENABLED) != 0 ? 
        true : false;
    }

    private void axWebBrowser1_CommandStateChange(object sender, AxSHDocVw.DWebBrowserEvents2_CommandStateChangeEvent e)
    {
      const int CSC_NAVIGATEBACK = 2;      // Back button  
      const int CSC_NAVIGATEFORWARD = 1;   // Forward button 
 
      switch(e.command)
      {
        case CSC_NAVIGATEFORWARD:
          toolBarButtonForward.Enabled = e.enable;
          break;
          
        case CSC_NAVIGATEBACK:
          toolBarButtonBack.Enabled = e.enable;
          break;
      }
    }

    private void axWebBrowser1_BeforeNavigate2(object sender, AxSHDocVw.DWebBrowserEvents2_BeforeNavigate2Event e)
    {
      Cursor = Cursors.WaitCursor;
      toolBarButtonStop.Enabled = true;
    }

    private void axWebBrowser1_NavigateComplete2(object sender, AxSHDocVw.DWebBrowserEvents2_NavigateComplete2Event e)
    {
      Cursor = Cursors.Default;

      UpdateToolbarButtonStates();

      // update the URL shown in the address box
      textBoxAddress.Text = e.uRL.ToString();
    }

    void UpdateToolbarButtonStates()
    {
      // update the toolbar button states
      toolBarButtonStop.Enabled = false;
      toolBarButtonHome.Enabled = true;
      toolBarButtonSearch.Enabled = true;
      toolBarButtonRefresh.Enabled = true;
      toolBarButtonPrint.Enabled = IsCommandEnabled(SHDocVw.OLECMDID.OLECMDID_PRINT);
      toolBarButtonFileSave.Enabled = IsCommandEnabled(SHDocVw.OLECMDID.OLECMDID_SAVEAS);
    }

    private void PrintPage()
    {
      if (!IsCommandEnabled(SHDocVw.OLECMDID.OLECMDID_PRINT))
        return;

      object o = "";

      // constants useful when printing
      SHDocVw.OLECMDID Print = SHDocVw.OLECMDID.OLECMDID_PRINT;

      // use this value to print without prompting
      // SHDocVw.OLECMDEXECOPT PromptUser =
      //  SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_PROMPTUSER;

      SHDocVw.OLECMDEXECOPT DontPromptUser =
        SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DONTPROMPTUSER;
  
      // print without prompting user
      axWebBrowser1.ExecWB(Print, DontPromptUser, ref o, ref o);

      // to prompt the user with printer settings
      // axWebBrowser1.ExecWB(Print, PromptUser, ref o, ref o);
    }

    void SavePage()
    {
      if (!IsCommandEnabled(SHDocVw.OLECMDID.OLECMDID_SAVEAS))
        return;
      
      object o = null;

      axWebBrowser1.ExecWB(SHDocVw.OLECMDID.OLECMDID_SAVEAS, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_PROMPTUSER, ref o, ref o);

    }

    private void textBox1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Return)
        GotoUrl(textBoxAddress.Text);
    }

    void GotoUrl(string theUrl)
    {
      try 
      {
        Cursor.Current = Cursors.WaitCursor;
        Object o = null;
        axWebBrowser1.Navigate(theUrl, ref o, ref o, ref o, ref o);
      } 
      finally 
      {
        Cursor.Current = Cursors.Default;
      }
    }

    private void textBoxAddress_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
    {
      if (e.KeyChar == '\r')
      {
        e.Handled = true;  // to disable the 'beep'
      }
    }

    private void axWebBrowser1_NavigateError(object sender, AxSHDocVw.DWebBrowserEvents2_NavigateErrorEvent e)
    {
      Cursor.Current = Cursors.Default;
      UpdateToolbarButtonStates();
    }

    #region IOleClientSite methods

    void IOleClientSite.SaveObject() {}
    void IOleClientSite.GetMoniker(uint dwAssign, uint dwWhichMoniker, ref object ppmk) {}
    void IOleClientSite.GetContainer(ref object ppContainer) {ppContainer = this;}
    void IOleClientSite.ShowObject() {}
    void IOleClientSite.OnShowWindow(bool fShow) {}
    void IOleClientSite.RequestNewObjectLayout() {}

    #endregion

    #region IDocHostUIHandler methods

    public uint ShowContextMenu(uint dwID, ref tagPOINT ppt, object pcmdtReserved, object pdispReserved)
    {
      // use this code to show a custom menu
      const int MenuHandled = 0;
      Point p = new Point(ppt.x, ppt.y);
      p = PointToClient(p); 
      myCustomContextMenu.Show(this, p);
      return MenuHandled;

      // use this code to let MsHtml shows its menu
      // const int MenuNotHandled = 1;
      // return MenuNotHandled;
    }

    public void GetHostInfo(ref DOCHOSTUIINFO theHostUIInfo)
    {
      // turn three flags on
      theHostUIInfo.dwFlags |= (uint) (DOCHOSTUIFLAG.DOCHOSTUIFLAG_SCROLL_NO |
                                       DOCHOSTUIFLAG.DOCHOSTUIFLAG_NO3DBORDER |
                                       DOCHOSTUIFLAG.DOCHOSTUIFLAG_DIALOG);
    }

    public void ShowUI(uint dwID, ref object pActiveObject, ref object pCommandTarget, ref object pFrame, ref object pDoc) {}

    public void HideUI() {}

    public void UpdateUI() {}

    public void EnableModeless(int fEnable) {}

    public void OnDocWindowActivate(int fActivate) {}

    public void OnFrameWindowActivate(int fActivate) {}

    public void ResizeBorder(ref tagRECT prcBorder, int pUIWindow, int fRameWindow) {}

    public uint TranslateAccelerator(ref tagMSG lpMsg, ref Guid pguidCmdGroup, uint nCmdID)
    {
      const int KillAccelerator = 0;
      const int AllowAccelerator = 1;
      const int WM_KEYDOWN = 0x0100;
      
      if (lpMsg.message != WM_KEYDOWN)
        // allow message
        return AllowAccelerator;

      if ( (Control.ModifierKeys & Keys.Control) != Keys.Control) 
        return AllowAccelerator;

      // disable the Ctrl-N and Ctrl-P accelerators
      lpMsg.wParam &= 0xFF; // get the virtual keycode
      if ( (lpMsg.wParam == 'N') || ((lpMsg.wParam == 'P')) )
        return KillAccelerator; 

      // allow everything else
      return AllowAccelerator;
    }

    public void GetOptionKeyPath(ref string pchKey, uint dw) {}

    public object GetDropTarget(ref object pDropTarget) 
    {
      return pDropTarget;
    }

    // MsHtml will call this method when HTML page script of the form:
    //
    // <script language=\"jscript\">
    // function Button1_onclick()
    // {
    //   external.MyCustomMethod();
    // }
    // </script>
    //
    // is executed. MsHtml calls GetExternal to obtain the IDispatch interface of the
    // controlling host. Once MsHtml has that interface, it uses it to call the custom
    // method (e.g. MyCustomMethod).
    public void GetExternal([MarshalAs(UnmanagedType.IDispatch)] out object ppDispatch)
    {
      ppDispatch = this as ICustomMethods;
    }

    public uint TranslateUrl(uint dwTranslate, string URLIn, ref string URLOut)
    {
      const int NotTranslated = 1;
      
      return NotTranslated;

      // add code here to modify the Url the user 
      // is trying to navigate to. Ex:
      // prevent users from leaving your web site
      //      if (URLIn.IndexOf("mywebsite.com") < 0)
      //        URLOut = "http://www.mywebsite.com";
      //      else
      //        URLOut = URLIn;
      //
      //      const int Translated = 0;
      //      return Translated;
    }

    public IDataObject FilterDataObject(IDataObject pDO) 
    {
      return null;
    }

    #endregion

    #region IOleDocumentSite methods
    public void ActivateMe(ref object pViewToActivate) {}
    #endregion

    #region IDocHostShowUI methods

    public uint ShowMessage(IntPtr hwnd, string msgText, string msgCaption, 
                            uint dwType, string lpstrHelpFile, uint dwHelpContext,
                            out int lpResult)
    {
      // msgText is the contents of the MessageBox
      // msgCaption is the text on the MessageBox caption bar
      
      lpResult = 0;

      // return one of these values
      const int MessageHandled = 0;    // MsHtml won't display its MessageBox
      const int MessageNotHandled = 1; // MsHtml will display its MessageBox

      // show a custom message, using a new caption. Be default, messages displayed 
      // by MsHtml have the caption "Microsoft Internet Explorer"
      MessageBox.Show(msgText, "MyCustomWebBrowser");
      return MessageHandled;
    }
                                  
    public uint ShowHelp(IntPtr hwnd, string pszHelpFile, uint uCommand, uint dwData, 
                         tagPOINT ptMouse, object pDispatchObjectHit)
    {
      // pDispatchObject will reference an object of type mshtml.HTMLDocumentClass, or 
      // other class representing something on the HTML page.
      
      // tagPOINT will normally be (0,0), unless ShowHelp() was called as the result of
      // clicking on an HTML element.

      // return one of these values
      const int HelpHandled = 0;    // MsHtml won't display its Help window
      const int HelpNotHandled = 1; // MsHtml will display its Help window

      return HelpNotHandled;
    }
                      
  #endregion

    #region ICustomMethods methods
    public void MyCustomMethod([MarshalAs(UnmanagedType.BStr)] string theCaption)
    {
      // just use a MessageBox
      string msg = "This messageBox was shown by a call from script on an HTML page, such as \n\n" +
                   "<script language=\"jscript\">\n" + 
                   "function Button1_onclick()\n" + 
                   "{\n" +
                   "  external.MyCustomMethod();\n" + 
                   "}\n" + 
                   "</script>\n\n" +
                   "You can also pass parameters to the custom method.\n" +
                   "The parameter passed in this demo was the string '" + theCaption + "'.";

      string caption = "Custom callbacks using IDocHostUIHandler.GetExternal()";
      MessageBox.Show(msg, caption);
    }
    #endregion

    private void axWebBrowser1_DownloadComplete(object sender, System.EventArgs e)
    {
      // This code shows how to talk directly to MsHtml to set the controlling host.
      // The code is not necessary in this demo, since the controlling host is
      // set in the class constructor above, using the code
      //
      // object obj = axWebBrowser1.GetOcx();
      // IOleObject oc = obj as IOleObject;
      // oc.SetClientSite(this);
      
//      IHTMLDocument2 htmlDocument = axWebBrowser1.Document as IHTMLDocument2;
//      if (htmlDocument == null) return;
//
//      ((ICustomDoc) htmlDocument).SetUIHandler(this as IDocHostUIHandler);
    }

  }
}
